diff --git a/MAINTAINERS b/MAINTAINERS
index 81ce7b4e2b2a..152fef3163e5 100644
--- a/MAINTAINERS
+++ b/MAINTAINERS
@@ -12130,7 +12130,7 @@ M:	Rick Chang <rick.chang@mediatek.com>
 M:	Bin Liu <bin.liu@mediatek.com>
 S:	Supported
 F:	Documentation/devicetree/bindings/media/mediatek-jpeg-decoder.txt
-F:	drivers/media/platform/mediatek/mtk-jpeg/
+F:	drivers/media/platform/mediatek/jpeg/
 
 MEDIATEK MDP DRIVER
 M:	Minghsiu Tsai <minghsiu.tsai@mediatek.com>
@@ -12138,8 +12138,8 @@ M:	Houlong Wei <houlong.wei@mediatek.com>
 M:	Andrew-CT Chen <andrew-ct.chen@mediatek.com>
 S:	Supported
 F:	Documentation/devicetree/bindings/media/mediatek-mdp.txt
-F:	drivers/media/platform/mediatek/mtk-mdp/
-F:	drivers/media/platform/mediatek/mtk-vpu/
+F:	drivers/media/platform/mediatek/mdp/
+F:	drivers/media/platform/mediatek/vpu/
 
 MEDIATEK MEDIA DRIVER
 M:	Tiffany Lin <tiffany.lin@mediatek.com>
@@ -12147,8 +12147,8 @@ M:	Andrew-CT Chen <andrew-ct.chen@mediatek.com>
 S:	Supported
 F:	Documentation/devicetree/bindings/media/mediatek-vcodec.txt
 F:	Documentation/devicetree/bindings/media/mediatek-vpu.txt
-F:	drivers/media/platform/mediatek/mtk-vcodec/
-F:	drivers/media/platform/mediatek/mtk-vpu/
+F:	drivers/media/platform/mediatek/vcodec/
+F:	drivers/media/platform/mediatek/vpu/
 
 MEDIATEK MMC/SD/SDIO DRIVER
 M:	Chaotian Jing <chaotian.jing@mediatek.com>
diff --git a/drivers/media/platform/mediatek/Kconfig b/drivers/media/platform/mediatek/Kconfig
index aa79626088ec..122eb94ed430 100644
--- a/drivers/media/platform/mediatek/Kconfig
+++ b/drivers/media/platform/mediatek/Kconfig
@@ -2,7 +2,7 @@
 
 comment "Mediatek drivers"
 
-source "drivers/media/platform/mediatek/mtk-jpeg/Kconfig"
-source "drivers/media/platform/mediatek/mtk-mdp/Kconfig"
-source "drivers/media/platform/mediatek/mtk-vcodec/Kconfig"
-source "drivers/media/platform/mediatek/mtk-vpu/Kconfig"
+source "drivers/media/platform/mediatek/jpeg/Kconfig"
+source "drivers/media/platform/mediatek/mdp/Kconfig"
+source "drivers/media/platform/mediatek/vcodec/Kconfig"
+source "drivers/media/platform/mediatek/vpu/Kconfig"
diff --git a/drivers/media/platform/mediatek/Makefile b/drivers/media/platform/mediatek/Makefile
index 403d5ecd2b10..d3850a13f128 100644
--- a/drivers/media/platform/mediatek/Makefile
+++ b/drivers/media/platform/mediatek/Makefile
@@ -1,5 +1,5 @@
 # SPDX-License-Identifier: GPL-2.0-only
-obj-y += mtk-jpeg/
-obj-y += mtk-mdp/
-obj-y += mtk-vcodec/
-obj-y += mtk-vpu/
+obj-y += jpeg/
+obj-y += mdp/
+obj-y += vcodec/
+obj-y += vpu/
diff --git a/drivers/media/platform/mediatek/mtk-jpeg/Kconfig b/drivers/media/platform/mediatek/jpeg/Kconfig
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-jpeg/Kconfig
rename to drivers/media/platform/mediatek/jpeg/Kconfig
diff --git a/drivers/media/platform/mediatek/mtk-jpeg/Makefile b/drivers/media/platform/mediatek/jpeg/Makefile
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-jpeg/Makefile
rename to drivers/media/platform/mediatek/jpeg/Makefile
diff --git a/drivers/media/platform/mediatek/mtk-jpeg/mtk_jpeg_core.c b/drivers/media/platform/mediatek/jpeg/mtk_jpeg_core.c
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-jpeg/mtk_jpeg_core.c
rename to drivers/media/platform/mediatek/jpeg/mtk_jpeg_core.c
diff --git a/drivers/media/platform/mediatek/mtk-jpeg/mtk_jpeg_core.h b/drivers/media/platform/mediatek/jpeg/mtk_jpeg_core.h
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-jpeg/mtk_jpeg_core.h
rename to drivers/media/platform/mediatek/jpeg/mtk_jpeg_core.h
diff --git a/drivers/media/platform/mediatek/mtk-jpeg/mtk_jpeg_dec_hw.c b/drivers/media/platform/mediatek/jpeg/mtk_jpeg_dec_hw.c
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-jpeg/mtk_jpeg_dec_hw.c
rename to drivers/media/platform/mediatek/jpeg/mtk_jpeg_dec_hw.c
diff --git a/drivers/media/platform/mediatek/mtk-jpeg/mtk_jpeg_dec_hw.h b/drivers/media/platform/mediatek/jpeg/mtk_jpeg_dec_hw.h
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-jpeg/mtk_jpeg_dec_hw.h
rename to drivers/media/platform/mediatek/jpeg/mtk_jpeg_dec_hw.h
diff --git a/drivers/media/platform/mediatek/mtk-jpeg/mtk_jpeg_dec_parse.c b/drivers/media/platform/mediatek/jpeg/mtk_jpeg_dec_parse.c
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-jpeg/mtk_jpeg_dec_parse.c
rename to drivers/media/platform/mediatek/jpeg/mtk_jpeg_dec_parse.c
diff --git a/drivers/media/platform/mediatek/mtk-jpeg/mtk_jpeg_dec_parse.h b/drivers/media/platform/mediatek/jpeg/mtk_jpeg_dec_parse.h
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-jpeg/mtk_jpeg_dec_parse.h
rename to drivers/media/platform/mediatek/jpeg/mtk_jpeg_dec_parse.h
diff --git a/drivers/media/platform/mediatek/mtk-jpeg/mtk_jpeg_dec_reg.h b/drivers/media/platform/mediatek/jpeg/mtk_jpeg_dec_reg.h
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-jpeg/mtk_jpeg_dec_reg.h
rename to drivers/media/platform/mediatek/jpeg/mtk_jpeg_dec_reg.h
diff --git a/drivers/media/platform/mediatek/mtk-jpeg/mtk_jpeg_enc_hw.c b/drivers/media/platform/mediatek/jpeg/mtk_jpeg_enc_hw.c
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-jpeg/mtk_jpeg_enc_hw.c
rename to drivers/media/platform/mediatek/jpeg/mtk_jpeg_enc_hw.c
diff --git a/drivers/media/platform/mediatek/mtk-jpeg/mtk_jpeg_enc_hw.h b/drivers/media/platform/mediatek/jpeg/mtk_jpeg_enc_hw.h
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-jpeg/mtk_jpeg_enc_hw.h
rename to drivers/media/platform/mediatek/jpeg/mtk_jpeg_enc_hw.h
diff --git a/drivers/media/platform/mediatek/mtk-mdp/Kconfig b/drivers/media/platform/mediatek/mdp/Kconfig
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-mdp/Kconfig
rename to drivers/media/platform/mediatek/mdp/Kconfig
diff --git a/drivers/media/platform/mediatek/mtk-mdp/Makefile b/drivers/media/platform/mediatek/mdp/Makefile
similarity index 77%
rename from drivers/media/platform/mediatek/mtk-mdp/Makefile
rename to drivers/media/platform/mediatek/mdp/Makefile
index eab6f984aeea..b7c16ebecc80 100644
--- a/drivers/media/platform/mediatek/mtk-mdp/Makefile
+++ b/drivers/media/platform/mediatek/mdp/Makefile
@@ -7,4 +7,4 @@ mtk-mdp-y += mtk_mdp_vpu.o
 
 obj-$(CONFIG_VIDEO_MEDIATEK_MDP) += mtk-mdp.o
 
-ccflags-y += -I$(srctree)/drivers/media/platform/mediatek/mtk-vpu
+ccflags-y += -I$(srctree)/drivers/media/platform/mediatek/vpu
diff --git a/drivers/media/platform/mediatek/mtk-mdp/mtk_mdp_comp.c b/drivers/media/platform/mediatek/mdp/mtk_mdp_comp.c
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-mdp/mtk_mdp_comp.c
rename to drivers/media/platform/mediatek/mdp/mtk_mdp_comp.c
diff --git a/drivers/media/platform/mediatek/mtk-mdp/mtk_mdp_comp.h b/drivers/media/platform/mediatek/mdp/mtk_mdp_comp.h
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-mdp/mtk_mdp_comp.h
rename to drivers/media/platform/mediatek/mdp/mtk_mdp_comp.h
diff --git a/drivers/media/platform/mediatek/mtk-mdp/mtk_mdp_core.c b/drivers/media/platform/mediatek/mdp/mtk_mdp_core.c
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-mdp/mtk_mdp_core.c
rename to drivers/media/platform/mediatek/mdp/mtk_mdp_core.c
diff --git a/drivers/media/platform/mediatek/mtk-mdp/mtk_mdp_core.h b/drivers/media/platform/mediatek/mdp/mtk_mdp_core.h
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-mdp/mtk_mdp_core.h
rename to drivers/media/platform/mediatek/mdp/mtk_mdp_core.h
diff --git a/drivers/media/platform/mediatek/mtk-mdp/mtk_mdp_ipi.h b/drivers/media/platform/mediatek/mdp/mtk_mdp_ipi.h
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-mdp/mtk_mdp_ipi.h
rename to drivers/media/platform/mediatek/mdp/mtk_mdp_ipi.h
diff --git a/drivers/media/platform/mediatek/mtk-mdp/mtk_mdp_m2m.c b/drivers/media/platform/mediatek/mdp/mtk_mdp_m2m.c
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-mdp/mtk_mdp_m2m.c
rename to drivers/media/platform/mediatek/mdp/mtk_mdp_m2m.c
diff --git a/drivers/media/platform/mediatek/mtk-mdp/mtk_mdp_m2m.h b/drivers/media/platform/mediatek/mdp/mtk_mdp_m2m.h
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-mdp/mtk_mdp_m2m.h
rename to drivers/media/platform/mediatek/mdp/mtk_mdp_m2m.h
diff --git a/drivers/media/platform/mediatek/mtk-mdp/mtk_mdp_regs.c b/drivers/media/platform/mediatek/mdp/mtk_mdp_regs.c
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-mdp/mtk_mdp_regs.c
rename to drivers/media/platform/mediatek/mdp/mtk_mdp_regs.c
diff --git a/drivers/media/platform/mediatek/mtk-mdp/mtk_mdp_regs.h b/drivers/media/platform/mediatek/mdp/mtk_mdp_regs.h
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-mdp/mtk_mdp_regs.h
rename to drivers/media/platform/mediatek/mdp/mtk_mdp_regs.h
diff --git a/drivers/media/platform/mediatek/mtk-mdp/mtk_mdp_vpu.c b/drivers/media/platform/mediatek/mdp/mtk_mdp_vpu.c
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-mdp/mtk_mdp_vpu.c
rename to drivers/media/platform/mediatek/mdp/mtk_mdp_vpu.c
diff --git a/drivers/media/platform/mediatek/mtk-mdp/mtk_mdp_vpu.h b/drivers/media/platform/mediatek/mdp/mtk_mdp_vpu.h
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-mdp/mtk_mdp_vpu.h
rename to drivers/media/platform/mediatek/mdp/mtk_mdp_vpu.h
diff --git a/drivers/media/platform/mediatek/mtk-vcodec/Kconfig b/drivers/media/platform/mediatek/vcodec/Kconfig
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-vcodec/Kconfig
rename to drivers/media/platform/mediatek/vcodec/Kconfig
diff --git a/drivers/media/platform/mediatek/mtk-vcodec/Makefile b/drivers/media/platform/mediatek/vcodec/Makefile
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-vcodec/Makefile
rename to drivers/media/platform/mediatek/vcodec/Makefile
diff --git a/drivers/media/platform/mediatek/mtk-vcodec/mtk_vcodec_dec.c b/drivers/media/platform/mediatek/vcodec/mtk_vcodec_dec.c
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-vcodec/mtk_vcodec_dec.c
rename to drivers/media/platform/mediatek/vcodec/mtk_vcodec_dec.c
diff --git a/drivers/media/platform/mediatek/mtk-vcodec/mtk_vcodec_dec.h b/drivers/media/platform/mediatek/vcodec/mtk_vcodec_dec.h
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-vcodec/mtk_vcodec_dec.h
rename to drivers/media/platform/mediatek/vcodec/mtk_vcodec_dec.h
diff --git a/drivers/media/platform/mediatek/mtk-vcodec/mtk_vcodec_dec_drv.c b/drivers/media/platform/mediatek/vcodec/mtk_vcodec_dec_drv.c
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-vcodec/mtk_vcodec_dec_drv.c
rename to drivers/media/platform/mediatek/vcodec/mtk_vcodec_dec_drv.c
diff --git a/drivers/media/platform/mediatek/mtk-vcodec/mtk_vcodec_dec_hw.c b/drivers/media/platform/mediatek/vcodec/mtk_vcodec_dec_hw.c
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-vcodec/mtk_vcodec_dec_hw.c
rename to drivers/media/platform/mediatek/vcodec/mtk_vcodec_dec_hw.c
diff --git a/drivers/media/platform/mediatek/mtk-vcodec/mtk_vcodec_dec_hw.h b/drivers/media/platform/mediatek/vcodec/mtk_vcodec_dec_hw.h
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-vcodec/mtk_vcodec_dec_hw.h
rename to drivers/media/platform/mediatek/vcodec/mtk_vcodec_dec_hw.h
diff --git a/drivers/media/platform/mediatek/mtk-vcodec/mtk_vcodec_dec_pm.c b/drivers/media/platform/mediatek/vcodec/mtk_vcodec_dec_pm.c
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-vcodec/mtk_vcodec_dec_pm.c
rename to drivers/media/platform/mediatek/vcodec/mtk_vcodec_dec_pm.c
diff --git a/drivers/media/platform/mediatek/mtk-vcodec/mtk_vcodec_dec_pm.h b/drivers/media/platform/mediatek/vcodec/mtk_vcodec_dec_pm.h
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-vcodec/mtk_vcodec_dec_pm.h
rename to drivers/media/platform/mediatek/vcodec/mtk_vcodec_dec_pm.h
diff --git a/drivers/media/platform/mediatek/mtk-vcodec/mtk_vcodec_dec_stateful.c b/drivers/media/platform/mediatek/vcodec/mtk_vcodec_dec_stateful.c
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-vcodec/mtk_vcodec_dec_stateful.c
rename to drivers/media/platform/mediatek/vcodec/mtk_vcodec_dec_stateful.c
diff --git a/drivers/media/platform/mediatek/mtk-vcodec/mtk_vcodec_dec_stateless.c b/drivers/media/platform/mediatek/vcodec/mtk_vcodec_dec_stateless.c
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-vcodec/mtk_vcodec_dec_stateless.c
rename to drivers/media/platform/mediatek/vcodec/mtk_vcodec_dec_stateless.c
diff --git a/drivers/media/platform/mediatek/mtk-vcodec/mtk_vcodec_drv.h b/drivers/media/platform/mediatek/vcodec/mtk_vcodec_drv.h
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-vcodec/mtk_vcodec_drv.h
rename to drivers/media/platform/mediatek/vcodec/mtk_vcodec_drv.h
diff --git a/drivers/media/platform/mediatek/mtk-vcodec/mtk_vcodec_enc.c b/drivers/media/platform/mediatek/vcodec/mtk_vcodec_enc.c
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-vcodec/mtk_vcodec_enc.c
rename to drivers/media/platform/mediatek/vcodec/mtk_vcodec_enc.c
diff --git a/drivers/media/platform/mediatek/mtk-vcodec/mtk_vcodec_enc.h b/drivers/media/platform/mediatek/vcodec/mtk_vcodec_enc.h
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-vcodec/mtk_vcodec_enc.h
rename to drivers/media/platform/mediatek/vcodec/mtk_vcodec_enc.h
diff --git a/drivers/media/platform/mediatek/mtk-vcodec/mtk_vcodec_enc_drv.c b/drivers/media/platform/mediatek/vcodec/mtk_vcodec_enc_drv.c
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-vcodec/mtk_vcodec_enc_drv.c
rename to drivers/media/platform/mediatek/vcodec/mtk_vcodec_enc_drv.c
diff --git a/drivers/media/platform/mediatek/mtk-vcodec/mtk_vcodec_enc_pm.c b/drivers/media/platform/mediatek/vcodec/mtk_vcodec_enc_pm.c
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-vcodec/mtk_vcodec_enc_pm.c
rename to drivers/media/platform/mediatek/vcodec/mtk_vcodec_enc_pm.c
diff --git a/drivers/media/platform/mediatek/mtk-vcodec/mtk_vcodec_enc_pm.h b/drivers/media/platform/mediatek/vcodec/mtk_vcodec_enc_pm.h
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-vcodec/mtk_vcodec_enc_pm.h
rename to drivers/media/platform/mediatek/vcodec/mtk_vcodec_enc_pm.h
diff --git a/drivers/media/platform/mediatek/mtk-vcodec/mtk_vcodec_fw.c b/drivers/media/platform/mediatek/vcodec/mtk_vcodec_fw.c
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-vcodec/mtk_vcodec_fw.c
rename to drivers/media/platform/mediatek/vcodec/mtk_vcodec_fw.c
diff --git a/drivers/media/platform/mediatek/mtk-vcodec/mtk_vcodec_fw.h b/drivers/media/platform/mediatek/vcodec/mtk_vcodec_fw.h
similarity index 97%
rename from drivers/media/platform/mediatek/mtk-vcodec/mtk_vcodec_fw.h
rename to drivers/media/platform/mediatek/vcodec/mtk_vcodec_fw.h
index 539bb626772c..15ab6b8e3ae2 100644
--- a/drivers/media/platform/mediatek/mtk-vcodec/mtk_vcodec_fw.h
+++ b/drivers/media/platform/mediatek/vcodec/mtk_vcodec_fw.h
@@ -6,7 +6,7 @@
 #include <linux/remoteproc.h>
 #include <linux/remoteproc/mtk_scp.h>
 
-#include "../mtk-vpu/mtk_vpu.h"
+#include "../vpu/mtk_vpu.h"
 
 struct mtk_vcodec_dev;
 
diff --git a/drivers/media/platform/mediatek/mtk-vcodec/mtk_vcodec_fw_priv.h b/drivers/media/platform/mediatek/vcodec/mtk_vcodec_fw_priv.h
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-vcodec/mtk_vcodec_fw_priv.h
rename to drivers/media/platform/mediatek/vcodec/mtk_vcodec_fw_priv.h
diff --git a/drivers/media/platform/mediatek/mtk-vcodec/mtk_vcodec_fw_scp.c b/drivers/media/platform/mediatek/vcodec/mtk_vcodec_fw_scp.c
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-vcodec/mtk_vcodec_fw_scp.c
rename to drivers/media/platform/mediatek/vcodec/mtk_vcodec_fw_scp.c
diff --git a/drivers/media/platform/mediatek/mtk-vcodec/mtk_vcodec_fw_vpu.c b/drivers/media/platform/mediatek/vcodec/mtk_vcodec_fw_vpu.c
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-vcodec/mtk_vcodec_fw_vpu.c
rename to drivers/media/platform/mediatek/vcodec/mtk_vcodec_fw_vpu.c
diff --git a/drivers/media/platform/mediatek/mtk-vcodec/mtk_vcodec_intr.c b/drivers/media/platform/mediatek/vcodec/mtk_vcodec_intr.c
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-vcodec/mtk_vcodec_intr.c
rename to drivers/media/platform/mediatek/vcodec/mtk_vcodec_intr.c
diff --git a/drivers/media/platform/mediatek/mtk-vcodec/mtk_vcodec_intr.h b/drivers/media/platform/mediatek/vcodec/mtk_vcodec_intr.h
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-vcodec/mtk_vcodec_intr.h
rename to drivers/media/platform/mediatek/vcodec/mtk_vcodec_intr.h
diff --git a/drivers/media/platform/mediatek/mtk-vcodec/mtk_vcodec_util.c b/drivers/media/platform/mediatek/vcodec/mtk_vcodec_util.c
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-vcodec/mtk_vcodec_util.c
rename to drivers/media/platform/mediatek/vcodec/mtk_vcodec_util.c
diff --git a/drivers/media/platform/mediatek/mtk-vcodec/mtk_vcodec_util.h b/drivers/media/platform/mediatek/vcodec/mtk_vcodec_util.h
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-vcodec/mtk_vcodec_util.h
rename to drivers/media/platform/mediatek/vcodec/mtk_vcodec_util.h
diff --git a/drivers/media/platform/mediatek/mtk-vcodec/vdec/vdec_h264_if.c b/drivers/media/platform/mediatek/vcodec/vdec/vdec_h264_if.c
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-vcodec/vdec/vdec_h264_if.c
rename to drivers/media/platform/mediatek/vcodec/vdec/vdec_h264_if.c
diff --git a/drivers/media/platform/mediatek/mtk-vcodec/vdec/vdec_h264_req_if.c b/drivers/media/platform/mediatek/vcodec/vdec/vdec_h264_req_if.c
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-vcodec/vdec/vdec_h264_req_if.c
rename to drivers/media/platform/mediatek/vcodec/vdec/vdec_h264_req_if.c
diff --git a/drivers/media/platform/mediatek/mtk-vcodec/vdec/vdec_vp8_if.c b/drivers/media/platform/mediatek/vcodec/vdec/vdec_vp8_if.c
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-vcodec/vdec/vdec_vp8_if.c
rename to drivers/media/platform/mediatek/vcodec/vdec/vdec_vp8_if.c
diff --git a/drivers/media/platform/mediatek/mtk-vcodec/vdec/vdec_vp9_if.c b/drivers/media/platform/mediatek/vcodec/vdec/vdec_vp9_if.c
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-vcodec/vdec/vdec_vp9_if.c
rename to drivers/media/platform/mediatek/vcodec/vdec/vdec_vp9_if.c
diff --git a/drivers/media/platform/mediatek/mtk-vcodec/vdec_drv_base.h b/drivers/media/platform/mediatek/vcodec/vdec_drv_base.h
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-vcodec/vdec_drv_base.h
rename to drivers/media/platform/mediatek/vcodec/vdec_drv_base.h
diff --git a/drivers/media/platform/mediatek/mtk-vcodec/vdec_drv_if.c b/drivers/media/platform/mediatek/vcodec/vdec_drv_if.c
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-vcodec/vdec_drv_if.c
rename to drivers/media/platform/mediatek/vcodec/vdec_drv_if.c
diff --git a/drivers/media/platform/mediatek/mtk-vcodec/vdec_drv_if.h b/drivers/media/platform/mediatek/vcodec/vdec_drv_if.h
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-vcodec/vdec_drv_if.h
rename to drivers/media/platform/mediatek/vcodec/vdec_drv_if.h
diff --git a/drivers/media/platform/mediatek/mtk-vcodec/vdec_ipi_msg.h b/drivers/media/platform/mediatek/vcodec/vdec_ipi_msg.h
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-vcodec/vdec_ipi_msg.h
rename to drivers/media/platform/mediatek/vcodec/vdec_ipi_msg.h
diff --git a/drivers/media/platform/mediatek/mtk-vcodec/vdec_msg_queue.c b/drivers/media/platform/mediatek/vcodec/vdec_msg_queue.c
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-vcodec/vdec_msg_queue.c
rename to drivers/media/platform/mediatek/vcodec/vdec_msg_queue.c
diff --git a/drivers/media/platform/mediatek/mtk-vcodec/vdec_msg_queue.h b/drivers/media/platform/mediatek/vcodec/vdec_msg_queue.h
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-vcodec/vdec_msg_queue.h
rename to drivers/media/platform/mediatek/vcodec/vdec_msg_queue.h
diff --git a/drivers/media/platform/mediatek/mtk-vcodec/vdec_vpu_if.c b/drivers/media/platform/mediatek/vcodec/vdec_vpu_if.c
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-vcodec/vdec_vpu_if.c
rename to drivers/media/platform/mediatek/vcodec/vdec_vpu_if.c
diff --git a/drivers/media/platform/mediatek/mtk-vcodec/vdec_vpu_if.h b/drivers/media/platform/mediatek/vcodec/vdec_vpu_if.h
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-vcodec/vdec_vpu_if.h
rename to drivers/media/platform/mediatek/vcodec/vdec_vpu_if.h
diff --git a/drivers/media/platform/mediatek/mtk-vcodec/venc/venc_h264_if.c b/drivers/media/platform/mediatek/vcodec/venc/venc_h264_if.c
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-vcodec/venc/venc_h264_if.c
rename to drivers/media/platform/mediatek/vcodec/venc/venc_h264_if.c
diff --git a/drivers/media/platform/mediatek/mtk-vcodec/venc/venc_vp8_if.c b/drivers/media/platform/mediatek/vcodec/venc/venc_vp8_if.c
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-vcodec/venc/venc_vp8_if.c
rename to drivers/media/platform/mediatek/vcodec/venc/venc_vp8_if.c
diff --git a/drivers/media/platform/mediatek/mtk-vcodec/venc_drv_base.h b/drivers/media/platform/mediatek/vcodec/venc_drv_base.h
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-vcodec/venc_drv_base.h
rename to drivers/media/platform/mediatek/vcodec/venc_drv_base.h
diff --git a/drivers/media/platform/mediatek/mtk-vcodec/venc_drv_if.c b/drivers/media/platform/mediatek/vcodec/venc_drv_if.c
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-vcodec/venc_drv_if.c
rename to drivers/media/platform/mediatek/vcodec/venc_drv_if.c
diff --git a/drivers/media/platform/mediatek/mtk-vcodec/venc_drv_if.h b/drivers/media/platform/mediatek/vcodec/venc_drv_if.h
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-vcodec/venc_drv_if.h
rename to drivers/media/platform/mediatek/vcodec/venc_drv_if.h
diff --git a/drivers/media/platform/mediatek/mtk-vcodec/venc_ipi_msg.h b/drivers/media/platform/mediatek/vcodec/venc_ipi_msg.h
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-vcodec/venc_ipi_msg.h
rename to drivers/media/platform/mediatek/vcodec/venc_ipi_msg.h
diff --git a/drivers/media/platform/mediatek/mtk-vcodec/venc_vpu_if.c b/drivers/media/platform/mediatek/vcodec/venc_vpu_if.c
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-vcodec/venc_vpu_if.c
rename to drivers/media/platform/mediatek/vcodec/venc_vpu_if.c
diff --git a/drivers/media/platform/mediatek/mtk-vcodec/venc_vpu_if.h b/drivers/media/platform/mediatek/vcodec/venc_vpu_if.h
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-vcodec/venc_vpu_if.h
rename to drivers/media/platform/mediatek/vcodec/venc_vpu_if.h
diff --git a/drivers/media/platform/mediatek/mtk-vpu/Kconfig b/drivers/media/platform/mediatek/vpu/Kconfig
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-vpu/Kconfig
rename to drivers/media/platform/mediatek/vpu/Kconfig
diff --git a/drivers/media/platform/mediatek/mtk-vpu/Makefile b/drivers/media/platform/mediatek/vpu/Makefile
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-vpu/Makefile
rename to drivers/media/platform/mediatek/vpu/Makefile
diff --git a/drivers/media/platform/mediatek/mtk-vpu/mtk_vpu.c b/drivers/media/platform/mediatek/vpu/mtk_vpu.c
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-vpu/mtk_vpu.c
rename to drivers/media/platform/mediatek/vpu/mtk_vpu.c
diff --git a/drivers/media/platform/mediatek/mtk-vpu/mtk_vpu.h b/drivers/media/platform/mediatek/vpu/mtk_vpu.h
similarity index 100%
rename from drivers/media/platform/mediatek/mtk-vpu/mtk_vpu.h
rename to drivers/media/platform/mediatek/vpu/mtk_vpu.h